package ru.myitschool.work.ui.login;

import androidx.lifecycle.LiveData;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.ViewModel;

import ru.myitschool.work.data.repository.LoginRepositoryImpl;
import ru.myitschool.work.domain.login.AuthUseCase;

public class LoginViewModel extends ViewModel {

    private final MutableLiveData<Boolean> mutableButtonStateLiveData = new MutableLiveData<>();
    public final LiveData<Boolean> buttonStateLiveData = mutableButtonStateLiveData;

    private final MutableLiveData<String> mutableLoginStateLiveData = new MutableLiveData<>();
    public final LiveData<String> loginStateLiveData = mutableLoginStateLiveData;


    private final AuthUseCase authUseCase = new AuthUseCase(LoginRepositoryImpl.getInstance());


    private String login;

    public void onChangeLogin(String login) {
        this.login = login;
        onChangeButtonState(login);
    }

    private void onChangeButtonState(String login) {
        if (login.length() >= 3 && !Character.isDigit(login.charAt(0)) && login.matches("^[a-zA-Z0-9]*$")) {
            mutableButtonStateLiveData.postValue(true);
        } else {
            mutableButtonStateLiveData.postValue(false);
        }
    }

    public void startQuery() {
        final String currentLogin = login;
        authUseCase.execute(currentLogin, status -> {
            if (status.getStatusCode() == 200) {
                mutableLoginStateLiveData.postValue("Correct Login");
            } else /*(status.getStatusCode() == 401) */ {
                mutableLoginStateLiveData.postValue("Incorrect Login");
            }
        });
    }
}
